install.md revision 1.23
1#	$OpenBSD: install.md,v 1.23 2022/02/06 15:52:23 krw Exp $
2#
3# Copyright (c) 1996 The NetBSD Foundation, Inc.
4# All rights reserved.
5#
6# This code is derived from software contributed to The NetBSD Foundation
7# by Jason R. Thorpe.
8#
9# Redistribution and use in source and binary forms, with or without
10# modification, are permitted provided that the following conditions
11# are met:
12# 1. Redistributions of source code must retain the above copyright
13#    notice, this list of conditions and the following disclaimer.
14# 2. Redistributions in binary form must reproduce the above copyright
15#    notice, this list of conditions and the following disclaimer in the
16#    documentation and/or other materials provided with the distribution.
17#
18# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
19# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
20# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
21# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE
22# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
23# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
24# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
25# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
26# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
27# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
28# POSSIBILITY OF SUCH DAMAGE.
29#
30#
31# machine dependent section of installation/upgrade script.
32#
33
34MDDKDEVS='/^[sw]d[0-9] /s/ .*//p;/^octcf[0-9] /s/ .*//p'
35NCPU=$(sysctl -n hw.ncpufound)
36
37md_installboot() {
38	if ! installboot -r /mnt ${1}; then
39		echo "\nFailed to install bootblocks."
40		echo "You will not be able to boot OpenBSD from ${1}."
41		exit
42	fi
43}
44
45md_prep_fdisk() {
46	local _disk=$1 _q _d
47
48	while :; do
49		_d=whole
50		if disk_has $_disk mbr; then
51			fdisk $_disk
52			if disk_has $_disk mbr openbsd; then
53				_q=", use the (O)penBSD area"
54				_d=OpenBSD
55			fi
56		else
57			echo "MBR has invalid signature; not showing it."
58		fi
59		ask "Use (W)hole disk$_q or (E)dit the MBR?" "$_d"
60		case $resp in
61		[wW]*)
62			echo -n "Creating a FAT partition and an OpenBSD partition for rest of $_disk..."
63			fdisk -iy -b "65536@64:C" ${_disk} >/dev/null
64			echo "done."
65			disklabel $_disk 2>/dev/null | grep -q "^  i:" || disklabel -w -d $_disk
66			newfs -t msdos ${_disk}i
67			return ;;
68		[eE]*)
69			# Manually configure the MBR.
70			cat <<__EOT
71
72You will now create one MBR partition to contain your OpenBSD data
73and one MBR partition on which kernels are located which are loaded
74by U-Boot. Neither partition will overlap any other partition.
75
76The OpenBSD MBR partition will have an id of 'A6' and the boot MBR
77partition will have an id of 'C' (MSDOS). The boot partition will be
78at least 32MB and be the first 'MSDOS' partition on the disk.
79
80$(fdisk ${_disk})
81__EOT
82			fdisk -e ${_disk}
83			disk_has $_disk mbr openbsd && return
84			echo No OpenBSD partition in MBR, try again. ;;
85		[oO]*)
86			[[ $_d == OpenBSD ]] || continue
87			return ;;
88		esac
89	done
90}
91
92md_prep_disklabel() {
93	local _disk=$1 _f=/tmp/i/fstab.$1
94
95	md_prep_fdisk $_disk
96
97	disklabel_autolayout $_disk $_f || return
98	[[ -s $_f ]] && return
99
100	# Edit disklabel manually.
101	# Abandon all hope, ye who enter here.
102	disklabel -F $_f -E $_disk
103}
104
105md_congrats() {
106	cat <<__EOT
107
108INSTALL.$ARCH describes how to configure U-Boot to boot OpenBSD.
109__EOT
110}
111
112md_consoleinfo() {
113}
114